########################################################################
# lor.tcl v1.93 by Vertigo@RusNet
# 
#  : 28--2008
#
#      www.lorquotes.ru
#
# :
#
# 1.    
# 2.       (scripts/)
# 3.      : source scripts/lor.tcl
# 4.     ,  .chanset #chan +lor
# 
# ---------------------------------------------------
#
# :
# !lor -   
# !lor <> -   
#
#
########################################################################
namespace eval lor {}

#############
#  #
#############

#  
set lor::prfx "!"
#   
set lor::check(delay) "30"
#      (  ,    )
set lor::count "6"
#   ( !lor    )
set lor::lock 1

set lor::mode_msg 0

##################
#   #
##################

#  
bind pub - ${lor::prfx}lor lor::lor
bind pub - ${lor::prfx} lor::lor

#  
bind msg - ${lor::prfx}lor lor::lor_msg
bind msg - ${lor::prfx} lor::lor_msg

#   ( )
bind pub n ${lor::prfx}lorlock lor::lorlock

#############################################################
#    ,   ,  ! #
#############################################################

setudef flag lor
package require http 2.5

proc lor::lor_msg {n u h t} {
set lor::mode_msg 1
lor::lor $n $u $h $n $t
}

proc lor::lorlock {n u h c t} {
if {$t == ""} {putquick "PRIVMSG $c :$n: Usage: !lorlock \<options\>. Options: on/off/status"; return}
switch -glob -- $t {
"on" {set lor::lock 1; putquick "PRIVMSG $c :$n: lorlock option is now \00309\002ON\002\003"; return}
"off" {set lor::lock 0; putquick "PRIVMSG $c :$n: lorlock option is now \00304\002OFF\002\003"; return}
"status" {return [switch -- [lindex $lor::lock] {1 {putserv "PRIVMSG $c :$n: lorlock option is now \002ON\002"} 0 {putserv "PRIVMSG $c :$n: lorlock option is now \002OFF\002"}}]}
default {putquick "PRIVMSG $c :$n: Bad options. Available options: on/off/status"; return}
}
}

proc lor::lor {n u h c t} {
if {$lor::mode_msg ne 1} {
if {![channel get $c lor]} {return}
}
set rran 0
if {[info exists lor::lock] && $lor::lock == "1" && ![matchattr $h n]} {putserv "NOTICE $n : !lor    ."; return}
if {$t ne "" && [info exists lor::check(lasttime,$u)] && [expr $lor::check(lasttime,$u) + $lor::check(delay)] > [clock seconds] && ![matchattr $h n]} {
     putserv "NOTICE $n : !lor      [lor::duration [expr $lor::check(delay) - [expr [clock seconds] - $lor::check(lasttime,$u)]]]."
     return
}

if { $t ne "" && ![regexp -all -- {[0-9]} $t] || [regexp -all -- {[a-zA-Z--߸\!\"\\%\;\:\?\*\(\)\_\-\+\=\/\]\[\{\}\|\'\>\<\~\`\$\#\@\^\&]} $t]} {putserv "NOTICE $n : .   ."; return}
set num [lindex $t 0]
if {$num eq ""} {set num [expr [rand 5000] +1]; set rran 1}
putlog "::Lor:: $n/$c :: $num"
set t [::http::geturl "http://www.lorquotes.ru/view-quote.php?id=$num" -timeout 120000]
set lor::check(lasttime,$u) [clock seconds]
set html [::http::data $t]
::http::cleanup $t
set html [encoding convertfrom koi8-r $html]
set a ""
regsub -all \n $html "" html
regexp -all -nocase -- {<div class="q-text">(.+?)<div class="q-sign">} $html -> a
if {$a eq "" && $rran eq 0} {putserv "PRIVMSG $c :     ."; return}
if {$a eq "" && $rran eq 1} {putserv "NOTICE $n :    ,   .    .   \:\)"; return}
set a [string map {{<b>} {} {</b>} {} {<br />} \n {<div class="q-reply">} \n {class="q-reply">} {} {<div class="q-re">} {} {&gt;} {>} {&quot;} {"} {<div } {} {	} {} {</div>} \n} $a]
set a [string trimleft $a "> "]
set a [string trimleft $a ">"]
set i 0
foreach d [split $a \n] {
if {$d eq ""} {continue}
incr i
}
set dest $c
if {$i >=$lor::count && $lor::mode_msg ne 1} {putserv "PRIVMSG $c :\00303$n\00310,  \00304$num\00310   \00303(\00307$i\00310 \00303)\00310.       .\003"; set dest $n}
set clr {{2} {12}}
set clr_o [lindex $clr [rand [llength $clr]]]
set clr_qo "\00303"
putserv "PRIVMSG $dest :$clr_o\.--- \00304$num$clr_o ---"
if {[string length [join [split $a]]] eq ""} {putserv "PRIVMSG $dest :$clr_o\`--- \00304end$clr_o ---"; return}
foreach d [split $a \n] {
if {$d eq ""} {continue}
if {[string length $d] <400} {putserv "PRIVMSG $dest :$clr_o\|$clr_qo $d"}
if {[llength [split $d]] >50} {putserv "PRIVMSG $dest :$clr_o\|$clr_qo [join [lrange [split $d] 0 60]]"; putserv "PRIVMSG $dest :$clr_o\|$clr_qo [join [lrange [split $d] 61 end]]"}
}
putserv "PRIVMSG $dest :$clr_o\`--- \00304end$clr_o ---"
set lor::mode_msg 0
}

proc lor::duration {seconds} {
global lor
	set minutes [expr {$seconds / 60}]
	set seconds [expr {$seconds % 60}]
	set res ""
	if {$minutes != 0} {lappend res [lor::numgrp $minutes "" "" ""]}
	if {$seconds != 0} {lappend res [lor::numgrp $seconds "" "" ""]}
	return [join $res ", "]
}
proc lor::numgrp {val str1 str2 str3} {
global dv
	set d1 [expr $val % 10]
	set d2 [expr $val % 100]
	if {$d2 < 10 || $d2 > 19} {
		if {$d1 == 1} {return "$val $str2"}
		if {$d1 >= 2 && $d1 <= 4} {return "$val $str3"}
	}
	return "$val $str1"
}
return "Lor.tcl v1.93 by Vertigo@RusNet loaded successfully."